package demo.areacharts ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.AbstractValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class XYAreaChartDemo2 extends JPanel {

  public XYAreaChartDemo2() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset1() ;
    IJChart chart = ChartFactory.createXYAreaChart("XY Area Chart Demo 2", "Time",
                                                   "Value", dataset, ChartOrientation.VERTICAL,
                                                   true, true, true, false) ;

    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setForegroundAlpha(0.5F) ;
    xyplot.setDomainGridlinePaint(Color.white) ;
    xyplot.setValueGridlinePaint(Color.white) ;

    AbstractValueAxis valueaxis = xyplot.getDomainAxis() ;
    valueaxis.setTickMarkPaint(Color.black) ;
    valueaxis.setLowerMargin(0.0D) ;
    valueaxis.setUpperMargin(0.0D) ;
    xyplot.getRender().setBackgroundPaint(Color.lightGray) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random 1") ;

    dataset.addRowData() ;
    Calendar cal = Calendar.getInstance() ;
    cal.set(Calendar.HOUR_OF_DAY, 0) ;
    cal.set(Calendar.MINUTE, 0) ;
    cal.set(Calendar.SECOND, 0) ;
    cal.set(Calendar.MILLISECOND, 0) ;

    double d = 0.0D ;
    for (int i = 0 ; i < 200 ; i++) {
      d = (d + Math.random()) - 0.5D ;
      dataset.addData(0, new XYNumberChartData(cal.getTimeInMillis(), d)) ;
      cal.add(Calendar.DAY_OF_MONTH, 1) ;
    }

    return dataset ;
  }

}
