package demo.barcharts.category ;

import java.awt.Color ;
import java.awt.Font ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.category.CategoryAxis ;
import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.HorizontalAlignment ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.Bar2DRender ;
import com.ijchart.xychart.title.TextTitle ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SurveyResultsDemo3 extends JPanel {
  private ChartOrientation orientation = ChartOrientation.HORIZONTAL ;

  public SurveyResultsDemo3() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel() ;
  }

  private void addPanel() {
    final IMatrixDataset dataset = createDataset() ;
    final IJChart chart = ChartFactory.createCategoryBar2DChart(
      "Figure 6 | Overall SEO Rating", null, null, dataset, orientation, true, true) ;

    TextTitle title = (TextTitle) chart.getTitle() ;
    title.setHorizontalAlignment(HorizontalAlignment.LEFT) ;
    title.setFillBackground(true) ;
    title.setBackgroundPaint(Color.red) ;
    title.setTextPaint(Color.white) ;
    title.setTextFont(new Font("SansSerif", Font.BOLD, 12)) ;

    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlineVisible(false) ;

    CategoryAxis categoryaxis = plot.getCategoryAxis() ;
    categoryaxis.setTickLabelFont(new Font("SansSerif", 1, 12)) ;
    categoryaxis.setCategoryMargin(0.29999999999999999D) ;
    categoryaxis.setTickMarkVisible(true);

    NumberValueAxis valueAxis = (NumberValueAxis) plot.getValueAxis() ;
    valueAxis.setUserDefineDatasetRange(0, 4) ;
    valueAxis.setVisible(false) ;

    Bar2DRender render = (Bar2DRender) plot.getRender() ;
    render.setAutoSelectFillPaint(false) ;
    render.setColumnItemFillPaint(0, new Color(156, 164, 74)) ;
    render.setBaseItemLabelVisible(true);
    render.setBaseItemLabelHorizontalAlignment(HorizontalAlignment.RIGHT);
    render.setBaseItemLabelFont(new Font("SansSerif", 0, 18));


    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Results") ;
    dataset.addRowKey("Sm.(10)") ;
    dataset.addRowKey("Med.(10)") ;
    dataset.addRowKey("Lg.(10)") ;
    dataset.addRowKey("All(10)") ;

    double data[] = {2.6099999999999999D,2.7000000000000002D,2.8999999999999999D,2.7400000000000002D
    } ;

    dataset.addRowData(data.length) ;
    for (int i = 0 ; i < data.length ; i++) {
      dataset.addData(i, new NumberChartData(data[i])) ;
    }

    return dataset ;
  }

}
