package demo.images ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.plot.NoAxisPlot ;
import com.ijchart.xychart.render.noaxis.SpiderWebRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SpiderChartHotspotTest {

  public IJChart createChart() {
    DefaultMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createSpiderWebChart("Spider Web Chart Demo 1",
                                                      dataset, true, true) ;
    NoAxisPlot plot = (NoAxisPlot) chart.getPlot() ;
    SpiderWebRender render = (SpiderWebRender) plot.getRender() ;
    render.setBaseItemFill(true) ;

    return chart ;
  }

  private static DefaultMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("First") ;
    dataset.addRowKey("Second") ;
    dataset.addRowKey("Third") ;

    dataset.addColKey("Category 1") ;
    dataset.addColKey("Category 2") ;
    dataset.addColKey("Category 3") ;
    dataset.addColKey("Category 4") ;
    dataset.addColKey("Category 5") ;

    dataset.addRowData(3) ;
    dataset.addData(0, new NumberChartData(1.0D)) ;
    dataset.addData(0, new NumberChartData(4D)) ;
    dataset.addData(0, new NumberChartData(3D)) ;
    dataset.addData(0, new NumberChartData(5D)) ;
    dataset.addData(0, new NumberChartData(5D)) ;

    dataset.addData(1, new NumberChartData(5D)) ;
    dataset.addData(1, new NumberChartData(7D)) ;
    dataset.addData(1, new NumberChartData(6D)) ;
    dataset.addData(1, new NumberChartData(8D)) ;
    dataset.addData(1, new NumberChartData(4D)) ;

    dataset.addData(2, new NumberChartData(4D)) ;
    dataset.addData(2, new NumberChartData(3D)) ;
    dataset.addData(2, new NumberChartData(2D)) ;
    dataset.addData(2, new NumberChartData(3D)) ;
    dataset.addData(2, new NumberChartData(6D)) ;

    return dataset ;
  }

}
