package demo.miscellaneous;

import java.awt.BorderLayout ;
import java.awt.Color ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYZNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYZNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.label.DefaultLabelGenerator ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.range.NumberRange ;
import com.ijchart.xychart.render.xy.XYBubbleRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class BubbleChartDemo2 extends JPanel {

  public BubbleChartDemo2() {
    setLayout(new BorderLayout()) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYBubbleChart("Bubble Chart Demo 2", "X",
                                                     "Y", dataset, ChartOrientation.VERTICAL, true,
                                                     true, false, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    xyplot.setForegroundAlpha(0.65F) ;

    XYBubbleRender render = (XYBubbleRender) xyplot.getRender() ;
    render.setScaleType(XYBubbleRender.SCALE_ON_BOTH_AXES) ;
    render.setAutoSelectFillPaint(false) ;
    render.setRowItemFillPaint(0, Color.blue) ;
    render.setRowItemFillPaint(1, Color.red) ;
    render.setBaseItemLabelVisible(true) ;
    render.setLabelGenerator(new DefaultLabelGenerator() {
      public String generateLabel(IMatrixDataset dataset, int row, int column) {
        XYZNumberChartData data = (XYZNumberChartData) dataset.getData(row, column) ;
        return data.getZData().toString() ;
      }

    }) ;

    XYZNumberValueAxis xAxis = (XYZNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setUserDefineDatasetRange(new NumberRange(0.0, 10D)) ;
    XYZNumberValueAxis yAxis = (XYZNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setUserDefineDatasetRange(new NumberRange(0.0, 10D)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;

    double xVal[][] = { {1.0D, 2D, 3D}, {4D, 5D, 611D}
    } ;

    double yVal[][] = { {1.0D, 2D, 3D}, {4D, 5D, 624D}
    } ;

    double zVal[][] = { {1.1000000000000001D, 2.2000000000000002D, 3.2999999999999998D}, {
                      4.4000000000000004D, 5.5D, 618.5999999999999996D}
    } ;

    dataset.addRowData(xVal.length) ;
    for (int i = 0 ; i < xVal.length ; i++) {
      dataset.addRowKey("Series " + (i + 1)) ;
      for (int j = 0 ; j < xVal[i].length ; j++) {
        dataset.addData(i, new XYZNumberChartData(xVal[i][j], yVal[i][j], zVal[i][j])) ;
      }
    }

    return dataset ;
  }

}
