package demo.miscellaneous ;

import java.awt.BorderLayout ;
import java.awt.event.ActionEvent ;
import java.awt.event.ActionListener ;

import javax.swing.JCheckBox ;
import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.StatisticalChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.AbstractCategoryRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class HideSeriesDemo2 extends JPanel implements ActionListener {
  private IJChart chart ;

  public HideSeriesDemo2() {
    setLayout(new BorderLayout()) ;
    addPanel1() ;

    JPanel jpanel = new JPanel() ;
    JCheckBox jcheckbox = new JCheckBox("Series 1") ;
    jcheckbox.setActionCommand("S1") ;
    jcheckbox.addActionListener(this) ;
    jcheckbox.setSelected(true) ;
    JCheckBox jcheckbox1 = new JCheckBox("Series 2") ;
    jcheckbox1.setActionCommand("S2") ;
    jcheckbox1.addActionListener(this) ;
    jcheckbox1.setSelected(true) ;
    JCheckBox jcheckbox2 = new JCheckBox("Series 3") ;
    jcheckbox2.setActionCommand("S3") ;
    jcheckbox2.addActionListener(this) ;
    jcheckbox2.setSelected(true) ;
    jpanel.add(jcheckbox) ;
    jpanel.add(jcheckbox1) ;
    jpanel.add(jcheckbox2) ;
    add(jpanel, BorderLayout.SOUTH) ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    chart = ChartFactory.createStaticalLineChart("Hide Series Demo 2", "X", "Y", dataset,
                                                 ChartOrientation.VERTICAL, true, true) ;
    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel, BorderLayout.CENTER) ;
  }

  public static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Column 1") ;
    dataset.addColKey("Column 2") ;
    dataset.addColKey("Column 3") ;
    dataset.addColKey("Column 4") ;

    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowKey("Series 3") ;

    dataset.addRowData(3) ;

    dataset.addData(0, new StatisticalChartData(10D, 2.3999999999999999D)) ;
    dataset.addData(0, new StatisticalChartData(15D, 4.4000000000000004D)) ;
    dataset.addData(0, new StatisticalChartData(13D, 2.1000000000000001D)) ;
    dataset.addData(0, new StatisticalChartData(7D, 1.3D)) ;

    dataset.addData(1, new StatisticalChartData(22D, 2.3999999999999999D)) ;
    dataset.addData(1, new StatisticalChartData(18D, 4.4000000000000004D)) ;
    dataset.addData(1, new StatisticalChartData(28D, 2.1000000000000001D)) ;
    dataset.addData(1, new StatisticalChartData(7D, 1.3D)) ;

    dataset.addData(2, new StatisticalChartData(2D, 2.3999999999999999D)) ;
    dataset.addData(2, new StatisticalChartData(8D, 4.4000000000000004D)) ;
    dataset.addData(2, new StatisticalChartData(8D, 2.1000000000000001D)) ;
    dataset.addData(2, new StatisticalChartData(7D, 1.3D)) ;

    return dataset ;
  }

  public void actionPerformed(ActionEvent actionevent) {
    int row = -1 ;
    if (actionevent.getActionCommand().equals("S1")) {
      row = 0 ;
    } else if (actionevent.getActionCommand().equals("S2")) {
      row = 1 ;
    } else if (actionevent.getActionCommand().equals("S3")) {
      row = 2 ;
    }

    if (row >= 0) {
      CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
      AbstractCategoryRender render = plot.getRender() ;
      Boolean flag = render.isRowItemVisible(row) ;
      render.setRowItemVisible(row, flag == null ? false : !flag.booleanValue()) ;
    }

  }
}
