package demo.miscellaneous;

import java.awt.BorderLayout ;
import java.awt.Color ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.WindChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.WindRender ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class WindChartDemo1 extends JPanel {

  public WindChartDemo1() {
    setLayout(new BorderLayout()) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createWindChart(
      "Wind Chart Demo", "Date", "Direction / Force", dataset, ChartOrientation.VERTICAL,
      true, true, true, false) ;

    XYPlot plot = (XYPlot) chart.getPlot() ;

    WindRender render = (WindRender) plot.getRender() ;
    render.setBaseItemLabelVisible(true) ;
    render.setBaseItemLabelPaint(Color.blue) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset ds = new DefaultMatrixDataset() ;

    ds.addRowData() ;
    ds.addRowKey("Series 1") ;

    ds.addData(0, createItem(millisForDate(3, 1, 1999), 0, 10)) ;
    ds.addData(0, createItem(millisForDate(4, 1, 1999), 1, 8)) ;
    ds.addData(0, createItem(millisForDate(5, 1, 1999), 2, 10)) ;
    ds.addData(0, createItem(millisForDate(6, 1, 1999), 3, 10)) ;
    ds.addData(0, createItem(millisForDate(7, 1, 1999), 4, 7)) ;
    ds.addData(0, createItem(millisForDate(8, 1, 1999), 5, 10)) ;
    ds.addData(0, createItem(millisForDate(9, 1, 1999), 6, 8)) ;
    ds.addData(0, createItem(millisForDate(10, 1, 1999), 7, 11)) ;
    ds.addData(0, createItem(millisForDate(11, 1, 1999), 8, 10)) ;
    ds.addData(0, createItem(millisForDate(12, 1, 1999), 9, 11)) ;
    ds.addData(0, createItem(millisForDate(13, 1, 1999), 10, 3)) ;
    ds.addData(0, createItem(millisForDate(14, 1, 1999), 11, 9)) ;
    ds.addData(0, createItem(millisForDate(15, 1, 1999), 12, 11)) ;
    ds.addData(0, createItem(millisForDate(16, 1, 1999), 0, 0)) ;

    return ds ;
  }

  private static long millisForDate(int i, int j, int k) {
    Calendar calendar = Calendar.getInstance() ;
    calendar.set(k, j - 1, i, 12, 0) ;
    return calendar.getTimeInMillis() ;
  }

  private static WindChartData createItem(long l, int i, int j) {
    return new WindChartData(l, i, j) ;
  }

}
