package demo.multipleaxischarts ;

import java.awt.Color ;
import java.awt.GridLayout ;
import java.util.Arrays ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.NumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.constant.IAngle ;
import com.ijchart.xychart.data.NumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.NumberFormatter ;
import com.ijchart.xychart.plot.CategoryPlot ;
import com.ijchart.xychart.render.category.LineAndShapeRender ;
import com.ijchart.xychart.util.ArrayUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ParetoChartDemo1 extends JPanel {
  public ParetoChartDemo1() {
    setLayout(new GridLayout(1, 1)) ;
    createPanel1() ;
  }

  public void createPanel1() {
    IMatrixDataset dataset1 = createDataset1() ;
    IMatrixDataset dataset2 = createDataset2() ;
    IJChart chart = ChartFactory.createCategoryBar2DChart("Freshmeat Software Projects", "Language",
                                                          "Projects", dataset1,
                                                          ChartOrientation.VERTICAL, true, true) ;
    CategoryPlot plot = (CategoryPlot) chart.getPlot() ;
    plot.setDomainGridlinePaint(Color.white) ;
    plot.setValueGridlinePaint(Color.white) ;
    plot.getValueAxis().setUpperMargin(0.02) ;

    NumberValueAxis valuesAxis2 = new NumberValueAxis("Percent", dataset2) ;
    valuesAxis2.setUpperMargin(0.02) ;
    valuesAxis2.setAxisLabelAngle(IAngle.ANGLE_DOWN_90) ;
    valuesAxis2.setTickValueFormatter(new NumberFormatter("0%"));
    plot.setValueAxis(1, valuesAxis2) ;

    LineAndShapeRender shapeRender = new LineAndShapeRender(dataset2) ;
    plot.setRender(1, shapeRender) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset1() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addColKey("Language") ;

    dataset.addRowKey("C") ;
    dataset.addRowKey("C++") ;
    dataset.addRowKey("C#") ;
    dataset.addRowKey("Java") ;
    dataset.addRowKey("Perl") ;
    dataset.addRowKey("PHP") ;
    dataset.addRowKey("Python") ;
    dataset.addRowKey("Ruby") ;
    dataset.addRowKey("SQL") ;
    dataset.addRowKey("Unix Shell") ;

    double[] data = new double[] {4843, 2098, 26, 1901, 2507, 1689, 948, 100, 263, 485} ;
    Arrays.sort(data) ;
    ArrayUtil.reverseArray(data) ;

    for (int i = 0 ; i < data.length ; i++) {
      dataset.addRowData() ;
      dataset.addData(i, new NumberChartData(data[i])) ;
    }

    return dataset ;
  }

  private static IMatrixDataset createDataset2() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Cumulative") ;

    dataset.addColKey("C") ;
    dataset.addColKey("C++") ;
    dataset.addColKey("C#") ;
    dataset.addColKey("Java") ;
    dataset.addColKey("Perl") ;
    dataset.addColKey("PHP") ;
    dataset.addColKey("Python") ;
    dataset.addColKey("Ruby") ;
    dataset.addColKey("SQL") ;
    dataset.addColKey("Unix Shell") ;

    double[] data = new double[] {4843, 2098, 26, 1901, 2507, 1689, 948, 100, 263, 485} ;
    Arrays.sort(data) ;
    ArrayUtil.reverseArray(data) ;

    double[] newData = ArrayUtil.calculateCumulativePercentData(data) ;

    dataset.addRowData() ;
    for (int i = 0 ; i < newData.length ; i++) {
      dataset.addData(0, new NumberChartData(newData[i])) ;
    }

    return dataset ;
  }

}
