package demo.timeseriescharts ;

import java.awt.BasicStroke ;
import java.awt.GridLayout ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.format.MillisecondsToDateFormatter ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.util.DateUtil ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo12 extends JPanel {

  public TimeSeriesDemo12() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Sample Chart", "Date",
                                                           "Value", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           true, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;
    XYNumberValueAxis xAxis = (XYNumberValueAxis) xyplot.getDomainAxis() ;
    xAxis.setTickValueFormatter(new MillisecondsToDateFormatter("hh:mma")) ;
    xyplot.getValueAxis().setUpperMargin(0.03D) ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setRowItemBorderStroke(0, new BasicStroke(2.0F)) ;
    render.setRowItemBorderStroke(1, new BasicStroke(2.0F)) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Series 1") ;
    dataset.addRowKey("Series 2") ;
    dataset.addRowData(2) ;

    dataset.addData(0, createData(0, 0, 7, 12, 2003, 1.2D)) ;
    dataset.addData(0, createData(30, 12, 7, 12, 2003, 3D)) ;
    dataset.addData(0, createData(15, 14, 7, 12, 2003, 8D)) ;

    dataset.addData(1, createData(0, 3, 7, 12, 2003, 0.0D)) ;
    dataset.addData(1, createData(30, 9, 7, 12, 2003, 0.0D)) ;
    dataset.addData(1, createData(15, 10, 7, 12, 2003, 0.0D)) ;

    return dataset ;
  }

  private static XYNumberChartData createData(int minute, int hour, int day,
                                              int month, int year, double value) {
    return new XYNumberChartData(DateUtil.dateToTimeInMillis(year, month, day, hour, minute), value) ;
  }

}
