package demo.timeseriescharts ;

import java.awt.GridLayout ;
import java.util.Calendar ;

import javax.swing.JPanel ;

import com.ijchart.xychart.axis.value.XYNumberValueAxis ;
import com.ijchart.xychart.client.ChartFactory ;
import com.ijchart.xychart.client.ChartPanel ;
import com.ijchart.xychart.client.IJChart ;
import com.ijchart.xychart.constant.ChartOrientation ;
import com.ijchart.xychart.data.XYNumberChartData ;
import com.ijchart.xychart.dataset.DefaultMatrixDataset ;
import com.ijchart.xychart.dataset.IMatrixDataset ;
import com.ijchart.xychart.plot.XYPlot ;
import com.ijchart.xychart.render.xy.XYLineAndShapeRender ;
import com.ijchart.xychart.tickunit.LongTickUnit ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class TimeSeriesDemo5 extends JPanel {

  public TimeSeriesDemo5() {
    setLayout(new GridLayout(1, 1)) ;
    addPanel1() ;
  }

  private void addPanel1() {
    IMatrixDataset dataset = createDataset() ;
    IJChart chart = ChartFactory.createXYLineAndShapeChart("Test", "Day", "Value", dataset,
                                                           ChartOrientation.VERTICAL,
                                                           false, true, true, false) ;
    XYPlot xyplot = (XYPlot) chart.getPlot() ;

    XYLineAndShapeRender render = (XYLineAndShapeRender) xyplot.getRender() ;
    render.setBaseItemShapeVisible(false) ;

    XYNumberValueAxis yAxis = (XYNumberValueAxis) xyplot.getValueAxis() ;
    yAxis.setAxisRangeIncludeZero(false) ;
    yAxis.setTickUnit(new LongTickUnit()) ;

    ChartPanel chartpanel = new ChartPanel(chart) ;
    add(chartpanel) ;
  }

  private static IMatrixDataset createDataset() {
    DefaultMatrixDataset dataset = new DefaultMatrixDataset() ;
    dataset.addRowKey("Random Data") ;
    dataset.addRowData() ;

    Calendar cal = Calendar.getInstance() ;
    cal.clear() ;
    cal.set(1990, 0, 1) ;

    double d = 100D ;
    for (int i = 0 ; i < 4000 ; i++) {
      d = (d + Math.random()) - 0.5D ;
      dataset.addData(0, new XYNumberChartData(cal.getTimeInMillis(), d)) ;
      cal.add(Calendar.DAY_OF_MONTH, 1) ;
    }

    return dataset ;
  }

}
