package com.ijchart.xychart.constant ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ͼλ</zh>
 * <en>The constant for legend position.</en>
 *
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public final class LegendTitlePosition implements Serializable {
  /** @todo ûʵ־ĻƲ. */
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization</en>
   */
  private static final long serialVersionUID = -5721247676723733965L ;

  /**
   * <zh>renderϱ.</zh>
   * <en>The top of out render area.</en>
   */
  public static final LegendTitlePosition OUTER_RENDER_AREA_TOP = new LegendTitlePosition(
    "OUTER_RENDER_AREA_TOP") ;

  /**
   * <zh>renderⲿ±.</zh>
   * <en>The bottom of out render area.</en>
   */
  public static final LegendTitlePosition OUTER_RENDER_AREA_BOTTOM = new LegendTitlePosition(
    "OUTER_RENDER_AREA_BOTTOM") ;

  /**
   * <zh>renderⲿ.</zh>
   * <en>The left of out render area.</en>
   */
  public static final LegendTitlePosition OUTER_RENDER_AREA_LEFT = new LegendTitlePosition(
    "OUTER_RENDER_AREA_LEFT") ;

  /**
   * <zh>renderⲿұ.</zh>
   * <en>The right of out render area.</en>
   */
  public static final LegendTitlePosition OUTER_RENDER_AREA_RIGHT = new LegendTitlePosition(
    "OUTER_RENDER_AREA_RIGHT") ;

  /**
   * <zh>renderڲϽ.</zh>
   * <en>The top-left of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_TOP_LEFT = new LegendTitlePosition(
    "IN_RENDER_AREA_TOP_LEFT") ;

  /**
   * <zh>renderڲϱߵмλ.</zh>
   * <en>The top-center of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_TOP_CENTER = new LegendTitlePosition(
    "IN_RENDER_AREA_TOP_CENTER") ;

  /**
   * <zh>renderڲϱߵϽ.</zh>
   * <en>The top-right of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_TOP_RIGHT = new LegendTitlePosition(
    "IN_RENDER_AREA_TOP_RIGHT") ;

  /**
   * <zh>renderڲм.</zh>
   * <en>The center-left of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_CENTER_LEFT = new LegendTitlePosition(
    "IN_RENDER_AREA_CENTER_LEFT") ;

  /**
   * <zh>renderڲ.</zh>
   * <en>The center-center of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_CENTER_CENTER = new LegendTitlePosition(
    "IN_RENDER_AREA_CENTER_CENTER") ;

  /**
   * <zh>renderڲмҲ.</zh>
   * <en>The center-right of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_CENTER_RIGHT = new LegendTitlePosition(
    "IN_RENDER_AREA_CENTER_RIGHT") ;

  /**
   * <zh>renderڲĵ½.</zh>
   * <en>The bottom-left of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_BOTTOM_LEFT = new LegendTitlePosition(
    "IN_RENDER_AREA_BOTTOM_LEFT") ;

  /**
   * <zh>renderڲ²м.</zh>
   * <en>The bottom-center of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_BOTTOM_CENTER = new LegendTitlePosition(
    "IN_RENDER_AREA_BOTTOM_CENTER") ;

  /**
   * <zh>renderڲ½.</zh>
   * <en>The bottom-right of in render area.</en>
   */
  public static final LegendTitlePosition IN_RENDER_AREA_BOTTOM_RIGHT = new LegendTitlePosition(
    "IN_RENDER_AREA_BOTTOM_RIGHT") ;

  /**
   * <zh>.</zh>
   * <en>The name.</en>
   */
  private String name ;

  /**
   * <zh>˽йֹʵ.</zh>
   * <en>Private constructor to prevent instance.</en>
   *
   * @param name String <zh>.</zh>
   * <en>The name.</en>
   */
  private LegendTitlePosition(String name) {
    this.name = name ;
  }

  /**
   * <zh></zh>
   * <en>Returns a string representing the object.</en>
   * @return The string.
   */
  public String toString() {
    return this.name ;
  }

  /**
   * <zh>жλǷrenderڲ.</zh>
   * <en>Returns a boolean value that indiciate whether or not position is in render area.</en>
   *
   * @param position LegendTitlePosition <zh>{@link LegendTitlePosition} (Ϊnull).</zh>
   * <en>The {@link LegendTitlePosition} object (null not permitted).</en>
   *
   * @return boolean <zh>ֵ.</zh>
   * <en>A boolean.</en>
   */
  public static boolean isInRenderArea(LegendTitlePosition position) {
    if (position == null) {
      throw new IllegalArgumentException("Null 'position' argument.") ;
    }

    return position.equals(IN_RENDER_AREA_TOP_LEFT) || position.equals(IN_RENDER_AREA_TOP_CENTER)
      || position.equals(IN_RENDER_AREA_TOP_RIGHT) || position.equals(IN_RENDER_AREA_CENTER_LEFT)
      || position.equals(IN_RENDER_AREA_CENTER_CENTER)
      || position.equals(IN_RENDER_AREA_CENTER_RIGHT)
      || position.equals(IN_RENDER_AREA_BOTTOM_LEFT)
      || position.equals(IN_RENDER_AREA_BOTTOM_CENTER)
      || position.equals(IN_RENDER_AREA_BOTTOM_RIGHT) ;
  }

  /**
   * <zh>жλǷrenderⲿ.</zh>
   * <en>Returns a boolean value that indiciate whether or not position is out render area.</en>
   *
   * @param position LegendTitlePosition <zh>{@link LegendTitlePosition} (Ϊnull).</zh>
   * <en>The {@link LegendTitlePosition} object (null not permitted).</en>
   *
   * @return boolean <zh>ֵ.</zh>
   * <en>A boolean.</en>
   */
  public static boolean isOutRenderArea(LegendTitlePosition position) {
    if (position == null) {
      throw new IllegalArgumentException("Null 'position' argument.") ;
    }

    return position.equals(OUTER_RENDER_AREA_TOP) || position.equals(OUTER_RENDER_AREA_BOTTOM)
      || position.equals(OUTER_RENDER_AREA_LEFT) || position.equals(OUTER_RENDER_AREA_RIGHT) ;
  }

  /**
   * <zh>Ƿ.</zh>
   * <en>Returns true if this object is equal to the specified object, and false otherwise.</en>
   *
   * @param o  the other object.
   * @return A boolean.
   */
  public boolean equals(Object o) {
    if (this == o) {
      return true ;
    }
    if (!(o instanceof LegendTitlePosition)) {
      return false ;
    }

    LegendTitlePosition that = (LegendTitlePosition) o ;
    if (!this.name.equals(that.name)) {
      return false ;
    }

    return true ;
  }

  /**
   * <zh>hashcodeֵ.</zh>
   * <en>Returns a hash code value for the object</en>
   *
   * @return int <zh>hashcodeֵ.</zh>
   * <en>A hash code value for this object.</en>
   */
  public int hashCode() {
    return name.hashCode() ;
  }

}
