package com.ijchart.xychart.dataset ;

import java.io.Serializable ;

/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ֻһݵݼ.</zh>
 * <en>This dataset has one row data only.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class SingleRowDataset extends DefaultMatrixDataset implements Serializable, Cloneable {
  /**
   * <zh>л汾ID.</zh>
   * <en>For serialization.</en>
   */
  private static final long serialVersionUID = 5441539696179883241L ;

  /**
   * <zh>һ</zh>
   * <en>Add one row to data list.</en>
   */
  public void addRowData() {
    if (getRowCount() == 0) {
      super.addRowData(1) ;
    } else {
      throw new RuntimeException("The rows of dataset can not greater than 0.") ;
    }
  }

  /**
   * <zh>һӼ</zh>
   * <en>Add multiple rows to data list.</en>
   *
   * @param count int <zh>.</zh>
   * <en>.</en>
   */
  public void addRowData(int count) {
    if (getRowCount() > 0 || count > 1) {
      throw new RuntimeException("The rows of dataset can not greater than 0.") ;
    }

    if (getRowCount() == 0) {
      super.addRowData(1) ;
      fireDatasetChanged() ;
    }
  }


}
