package com.ijchart.xychart.web ;



/**
 * <p>Title: IJChart</p>
 *
 * <p>Description: a chart library for the Java(tm) platform.</p>
 * <zh>ڻȡΨһChart Id.</zh>
 * <en>Calculate the unique chart id.</en>
 * <p>Copyright: Copyright (c) 2013</p>
 *
 * <p>Company: </p>
 *
 * @author zhang feng min,shanghai china.
 * <a href="mailto:ijchartsh@gmail.com">Contract me by email.</a>
 * @version 1.0
 */
public class ChartID {

  /**
   * <zh>Ψһʵ.</zh>
   * <en>The unique instance.</en>
   */
  private static ChartID instance = new ChartID() ;

  /**
   * <zh>chart idʼֵ.</zh>
   * <en>The begin value of chart id.</en>
   */
  private static long chartId = System.currentTimeMillis() ;

  /**
   * <zh>˽й.</zh>
   * <en>The private constructor.</en>
   */
  private ChartID() {
  }

  /**
   * <zh>ȡΨһʵ.</zh>
   * <en>Returns the unique instance.</en>
   *
   * @return ChartID <zh>ChartID.</zh>
   * <en>The unique instance.</en>
   */
  public static ChartID getInstance() {
    return instance ;
  }

  /**
   * <zh>õһchart idֵ.</zh>
   * <en>Returns the next value of chart id.</en>
   *
   * @return long <zh>chart idֵ.</zh>
   * <en>The new chart id.</en>
   */
  public synchronized long getNextChartId() {
    return chartId++ ;
  }

}
